package sota;

import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Die Loggerinstanz zum Loggen von SOTA-Meldungen im Programmablauf.
 * 
 */
public class Logger {

	private static FileWriter fw = null;

	/**
	 * Loggt einen String.
	 * 
	 * @param s
	 *            der String
	 */
	public static void log(String s) {
		System.out.print(s);
		try {
			if (fw == null) {
				setLogWriter("sota.log", "SOTA coverage tool v1.0", "SOTA v1.0 LogFile");
			}
			fw.write(s.replace("\n", "\r\n"));
			fw.flush();

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * Loggt einen String mit Zeilenumbruch.
	 * 
	 * @param s
	 *            der String
	 */
	public static void logln(String s) {
		log(s + "\n");
	}

	/**
	 * Fhrt einen Zeilenumbruch durch.
	 */
	public static void logln() {
		logln("");
	}

	/**
	 * Loggt einen Int-Wert mit Zeilenumbruch.
	 * 
	 * @param i
	 *            der Int-Wert
	 */
	public static void logln(int i) {
		logln(i + "");
	}

	/**
	 * Setzt den Logwriter fr die Loggerklasse.
	 * 
	 * @param logFile
	 *            das Logfile
	 * @param initLine
	 *            die Init-Zeile fr die Ausgabe
	 * @param logInitLine
	 *            die Init-Zeile fr das Log
	 */
	public static void setLogWriter(String logFile, String initLine, String logInitLine) {

		Date dt = new Date();
		SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

		try {
			fw = new FileWriter(logFile);
			System.out.println(df.format(dt) + "\r\n" + initLine + "\r\n");
			fw.write(df.format(dt) + "\r\n" + logInitLine + "\r\n\r\n");
			fw.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		logln("\t Creating LogFile: " + logFile);
	}

	/**
	 * Loggen eines Stacktraces.
	 * 
	 * @param stackTrace
	 *            der StackTrace
	 */
	public static void logln(StackTraceElement[] stackTrace) {
		for (int i = 0; i < stackTrace.length; i++) {
			logln("\t" + stackTrace[i].toString());
		}
	}

}
