package sota.app;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

import sota.gui.views.CoverageView;
import sota.gui.views.CFGView;
import sota.gui.views.ISchemeView;
import sota.gui.views.LogView;
import sota.gui.views.MetricsView;
import sota.gui.views.NodeView;
import sota.gui.views.ProjectView;
import sota.gui.views.SourceView;
import sota.gui.views.TestView;

/**
 * Die Debug-Perspektive von SOTA. Enthlt zustzlich noch die beiden Ansichten NodeView und LogView.
 *
 */
public class DebugPerspective implements IPerspectiveFactory {

	public static final String PERSPECTIVE_ID = "sota.debugperspective";

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IPerspectiveFactory#createInitialLayout(org.eclipse.ui.IPageLayout)
	 */
	public void createInitialLayout(IPageLayout layout) {

		String editorArea = layout.getEditorArea();
		layout.setEditorAreaVisible(false);
		layout.setFixed(true);

		IFolderLayout centerFolder = layout.createFolder("CenterFolder", IPageLayout.LEFT, 1.f, editorArea);
		IFolderLayout leftFolder = layout.createFolder("LeftFolder", IPageLayout.LEFT, 0.255f, "CenterFolder");
		IFolderLayout lowerLeftFolder = layout.createFolder("LowerLeftFolder", IPageLayout.BOTTOM, 0.6f, "LeftFolder");

		centerFolder.addView(SourceView.ID);
		centerFolder.addView(CFGView.ID);
		centerFolder.addView(CoverageView.ID);
		centerFolder.addView(MetricsView.ID);
		centerFolder.addView(NodeView.ID);
		centerFolder.addView(LogView.ID);

		leftFolder.addView(ProjectView.ID);

		lowerLeftFolder.addView(TestView.ID);
		lowerLeftFolder.addView(ISchemeView.ID);

	}
}