package sota.ast.nodes;

/**
 * Interface fr die homogene Verarbeitung von Knoten mit berdeckungsinformationen, d.h. ASTStatementNodes und
 * ASTFunctionNodes.
 * 
 */

public interface IStatementNode {

	/**
	 * Gibt die Anzahl der berdeckungen zurck.
	 * 
	 * @return die Anzahl an berdeckungen
	 */
	public abstract int getNrHits();

	/**
	 * Setzt die berdeckungszahl auf einen Wert.
	 * 
	 * @param i
	 *            der Wert
	 */
	public abstract void setNrHits(int i);

	/**
	 * Erhht die berdeckungszahl um Eins.
	 * 
	 * @return die Zahl der berdeckungen
	 */
	public abstract int incNrHits();

	/**
	 * Setzt alle berdeckungsdaten zurck.
	 */
	public abstract void resetHits();

	/**
	 * Erhht die berdeckungszahl um einen Wert.
	 * 
	 * @param i
	 *            der Wert
	 * @return die Zahl der berdeckungen
	 */
	public abstract int incNrHits(int i);

	/**
	 * Verringert die berdeckungszahl um einen Wert.
	 * 
	 * @param i
	 *            der Wert
	 * @return die Zahl der berdeckungen
	 */
	public abstract int decNrHits(int i);

	/**
	 * Ausgabefunktion
	 */
	public abstract void print();

	/**
	 * Gibt die ID zurck.
	 * 
	 * @return die ID
	 */
	public abstract int getID();

}