package sota.ast.util;

import java.util.HashMap;

import sota.ast.nodes.IScopeNode;

/**
 * Klasse fr die globalen, von SOTA erstellten ISchemes, welche das Projekt komplett nach Level 1, 2 und 3
 * instrumentieren.
 * 
 */
public class GlobalInstrumentationScheme extends IScheme {

	int level;

	/**
	 * Der Konstruktor.
	 * 
	 * @param name
	 *            der Name des ISchemes
	 * @param level
	 *            das gewhlte Level
	 */
	public GlobalInstrumentationScheme(String name, int level) {
		super(name);
		this.level = level;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see sota.ast.util.IScheme#getDescription()
	 */
	public String getDescription() {
		return description;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see sota.ast.util.IScheme#getLevelMap()
	 */
	public HashMap<String, Integer> getLevelMap() {
		return levelMap;
	}

	/* (non-Javadoc)
	 * @see sota.ast.util.IScheme#getInstrumentationLevel(java.lang.String)
	 */
	public int getInstrumentationLevel(String idString) {
		return level;
	}

	/* (non-Javadoc)
	 * @see sota.ast.util.IScheme#getInstrumentationLevel(sota.ast.nodes.IScopeNode)
	 */
	public int getInstrumentationLevel(IScopeNode node) {
		return level;
	}
	

	/* (non-Javadoc)
	 * @see sota.ast.util.IScheme#hasInstrumentationLevel(java.lang.String)
	 */
	public boolean hasInstrumentationLevel(String idString) {
		return true;
	}
}
