package sota.ast.util;

import java.util.HashMap;

/**
 * Interface fr die Auswertung von TestCases und TestLogs.
 * 
 */
public interface ITestContainer {
	/**
	 * Liefert die Abbildung der Knoten-ID von Funktionsknoten auf die Anzahl ihrer Ausfhrungen nach Level.
	 * 
	 * @return die Map
	 */
	public HashMap<Integer, int[]> getInvokationMap();

	/**
	 * Liefert den Namen des Tests.
	 * 
	 * @return der Name
	 */
	public String getName();

	/**
	 * Liefert die Beschreibung des Tests.
	 * 
	 * @return die Beschreibung
	 */
	public String getDescription();

	/**
	 * Liefert den Namen des verwendeten ISchemes.
	 * 
	 * @return der IScheme-Name
	 */
	public String getISchemeName();

	/**
	 * Liefert die Anzahl an Pfaden im Test.
	 * 
	 * @return die Anzahl an Pfaden
	 */
	public int getNrOfPaths();

}
