package sota.gui.action;

import org.eclipse.jface.action.Action;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.ActionFactory.IWorkbenchAction;

import sota.app.Application;
import sota.ast.util.ASTManager;
import sota.ast.util.IScheme;
import sota.ast.util.ProjectConfig;
import sota.gui.GuiUpdateListener;

/**
 * Schliet das aktuelle Projekt.
 * 
 */
public class CloseProjectAction extends Action implements IWorkbenchAction, GuiUpdateListener {
	public final static String ID = "sota.gui.closeprojectaction";

	public IWorkbenchWindow window;

	public IScheme currentIScheme = null;

	/**
	 * Der Konstruktor der Aktion.
	 * 
	 * @param window
	 *            das zugehrige Window
	 */
	public CloseProjectAction(IWorkbenchWindow window) {
		this.window = window;
		setId(ID);
		setText("&Close Project");
		Application.getInstance().getASTManager().addGuiUpdateListener(this);
		setEnabled(false);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */
	public void run() {
		Application.getInstance().getASTManager().reinit();
		PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell().setText("SOTA");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.actions.ActionFactory.IWorkbenchAction#dispose()
	 */
	public void dispose() {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see sota.lang.java.ast.util.GuiUpdateListener#guiUpdate(sota.ast.util.ASTManager)
	 */
	public void guiUpdate(ASTManager ast) {
		setEnabled(ast.getProjectStatus() >= ProjectConfig.CONFIGURED);
	}
}
