package sota.gui.action;

import java.net.MalformedURLException;
import java.net.URL;

import org.eclipse.core.runtime.Platform;
import org.eclipse.jface.action.Action;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.ActionFactory.IWorkbenchAction;
import org.eclipse.ui.browser.IWebBrowser;
import org.eclipse.ui.browser.IWorkbenchBrowserSupport;

import sota.app.Application;

/**
 * Ruft die Hilfe auf, d.h. ffnet das Handbuch.
 * 
 */
public class HelpAction extends Action implements IWorkbenchAction {

	public final static String ID = "sota.gui.action.helpaction";

	@SuppressWarnings("unused")
	private IWorkbenchWindow window;

	/**
	 * Der Konstruktor der Aktion.
	 * 
	 * @param window
	 *            das zugehrige Window
	 */
	public HelpAction(IWorkbenchWindow window) {
		this.window = window;
		setId(ID);
		setText("&Manual");
		setToolTipText("Manual");
		setImageDescriptor(Application.getInstance().getImageRegistry().getDescriptor("manual"));
		setEnabled(true);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */
	public void run() {
		String bundleLocation = "file:///" + Platform.getLocation();

		try {
			IWorkbenchBrowserSupport support = PlatformUI.getWorkbench().getBrowserSupport();
			IWebBrowser browser = support.createBrowser("browser");
			String manualLocation = bundleLocation.substring(0, bundleLocation.lastIndexOf('/'))
					+ "/manual/manual.html";
			browser.openURL(new URL(manualLocation));
		} catch (PartInitException e) {
			e.printStackTrace();
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.actions.ActionFactory.IWorkbenchAction#dispose()
	 */
	public void dispose() {
		// TODO Auto-generated method stub

	}

}
