package sota.gui.action;

import org.eclipse.jface.action.Action;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.ActionFactory.IWorkbenchAction;

import sota.app.Application;

/**
 * ffnet ein erstelltes Projekt.
 * 
 */
public class OpenProjectAction extends Action implements IWorkbenchAction {
	private final IWorkbenchWindow window;

	public final static String ID = "sota.gui.openprojectaction";

	/**
	 * Der Konstruktor der Aktion.
	 * 
	 * @param window
	 *            das zugehrige Window
	 */
	public OpenProjectAction(IWorkbenchWindow window) {
		this.window = window;
		setId(ID);
		setText("&Open Project");
		setImageDescriptor(Application.getInstance().getImageRegistry().getDescriptor("openproject"));
		setToolTipText("Open Project");
		setEnabled(true);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */
	public void run() {
		FileDialog fd = new FileDialog(window.getShell(), SWT.OPEN);
		fd.setText("Open Project");
		fd.setFilterPath(System.getProperty("user.dir"));
		fd.setFilterNames(new String[] { "Project files (*.project)", "All files (*.*)" });
		fd.setFilterExtensions(new String[] { "*.project", "*.*" });
		String s = fd.open();
		if (s != null && s.length() > 0) {
			Application.getInstance().getASTManager().openProject(s,
					PlatformUI.getWorkbench().getActiveWorkbenchWindow(), false);
			PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell().setText(
					"SOTA - Project " + Application.getInstance().getASTManager().getConfiguration().getName());
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.actions.ActionFactory.IWorkbenchAction#dispose()
	 */
	public void dispose() {
		// TODO Auto-generated method stub
	}
}
