package sota.gui.action;

import java.io.File;

import org.eclipse.jface.action.Action;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.ActionFactory.IWorkbenchAction;

import sota.app.Application;

/**
 * Stellt die Originalversion der Quelldatein fr das ausgewhlte Projekt wieder her.
 * 
 */
public class RecoverProjectAction extends Action implements IWorkbenchAction {
	public final static String ID = "sota.gui.recoverprojectaction";

	public IWorkbenchWindow window;

	/**
	 * Der Konstruktor der Aktion.
	 * 
	 * @param window
	 *            das zugehrige Window
	 */
	public RecoverProjectAction(IWorkbenchWindow window) {
		this.window = window;
		setId(ID);
		setText("&Recover Project");
		setImageDescriptor(Application.getInstance().getImageRegistry().getDescriptor("restore"));
		setToolTipText("Recover Project");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */
	public void run() {

		FileDialog fd = new FileDialog(window.getShell(), SWT.OPEN);
		fd.setText("Open Project");
		fd.setFilterPath(System.getProperty("user.dir"));
		fd.setFilterNames(new String[] { "Project files (*.project)", "All files (*.*)" });
		fd.setFilterExtensions(new String[] { "*.project", "*.*" });

		String file = fd.open();

		if (file == null || !(new File(file)).exists())
			return;

		if (file != null && file.length() > 0) {
			Application.getInstance().getASTManager().openProject(file,
					PlatformUI.getWorkbench().getActiveWorkbenchWindow(), true);
			PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell().setText(
					"SOTA - Project " + Application.getInstance().getASTManager().getConfiguration().getName());
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.actions.ActionFactory.IWorkbenchAction#dispose()
	 */
	public void dispose() {
		// TODO Auto-generated method stub
	}

}