package sota.gui.action;

import org.eclipse.jface.action.Action;
import org.eclipse.ui.actions.ActionFactory.IWorkbenchAction;

import sota.app.Application;
import sota.ast.util.ASTManager;
import sota.ast.util.ProjectConfig;
import sota.gui.GuiUpdateListener;

/**
 * Speichert das aktuelle Projekt.
 * 
 */
public class SaveProjectAction extends Action implements IWorkbenchAction, GuiUpdateListener {
	public final static String ID = "sota.gui.saveprojectaction";

	/**
	 * Der Konstruktor der Aktion.
	 * 
	 * @param window
	 *            das zugehrige Window
	 */
	public SaveProjectAction() {
		setId(ID);
		setImageDescriptor(Application.getInstance().getImageRegistry().getDescriptor("saveproject"));
		// setDisabledImageDescriptor(Application.getInstance().getImageRegistry().getDescriptor("saveprojectdis"));
		setText("&Save Project");
		setToolTipText("Save Project");
		Application.getInstance().getASTManager().addGuiUpdateListener(this);
		setEnabled(false);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */
	public void run() {
		Application.getInstance().getASTManager().saveProject();

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.actions.ActionFactory.IWorkbenchAction#dispose()
	 */
	public void dispose() {
		// TODO Auto-generated method stub
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see sota.lang.java.ast.util.GuiUpdateListener#guiUpdate(sota.ast.util.ASTManager)
	 */
	public void guiUpdate(ASTManager ast) {
		setEnabled(ast.getProjectStatus() >= ProjectConfig.PARSED);
	}
}