package sota.gui.action;

import org.eclipse.jface.action.Action;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.actions.ActionFactory.IWorkbenchAction;

import sota.app.Application;
import sota.ast.util.ASTManager;
import sota.ast.util.ProjectConfig;
import sota.gui.GuiUpdateListener;
import sota.gui.dialogs.UpdateSourcesDialog;

/**
 * Whlt die Quelldateien fr das aktuelle Projekt aus.
 * 
 */
public class SelectSourcesAction extends Action implements IWorkbenchAction, GuiUpdateListener {
	public final static String ID = "sota.gui.updatesoureceaction";
	IWorkbenchWindow window;

	/**
	 * Der Konstruktor der Aktion.
	 * 
	 * @param window
	 *            das zugehrige Window
	 */
	public SelectSourcesAction(IWorkbenchWindow window) {
		this.window = window;
		setId(ID);
		setText("&Select Sources");
		setImageDescriptor(Application.getInstance().getImageRegistry().getDescriptor("update"));
		setToolTipText("Select Sources");
		Application.getInstance().getASTManager().addGuiUpdateListener(this);
		setEnabled(false);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */
	public void run() {
		ASTManager ast = Application.getInstance().getASTManager();
		UpdateSourcesDialog dlg = new UpdateSourcesDialog(window.getShell());

		dlg.open();
		if (ast.getProjectStatus() < ProjectConfig.PARSED) {
			ast.parseProject(window);
			ast.backupProject();
			Application.getInstance().getASTManager().saveProject();
		}

		/*
		 * TreeSet<String> set = Application.getInstance().getConfiguration().getListOfTestFiles(); if(set.size() > 0) {
		 * if(Application.getInstance().getASTManager().getSourceStatus() == ProjectConfig.DIRTY) {
		 * Application.getInstance().getASTManager().restoreProject();
		 * Application.getInstance().getASTManager().reinit(Application
		 * .getInstance().getASTManager().getConfiguration());
		 * Application.getInstance().getASTManager().parseProject(window); }
		 * Application.getInstance().getASTManager().showCoverage(true);
		 * 
		 * Application.getInstance().getASTManager().readLog(set, window); set.clear(); }
		 */
		// ast.reinit(ast.getConfiguration());
		// ast.parseProject(window);
		// ast.backupProject();
		// PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell().setText("SOTA - Project " +
		// ast.getConfiguration().getName() );
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.actions.ActionFactory.IWorkbenchAction#dispose()
	 */
	public void dispose() {
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see sota.lang.java.ast.util.GuiUpdateListener#guiUpdate(sota.ast.util.ASTManager)
	 */
	@Override
	public void guiUpdate(ASTManager ast) {
		setEnabled(ast.getProjectStatus() >= ProjectConfig.PARSED);

	}

}
