package sota.gui.dialogs;

import java.io.File;

import org.eclipse.jface.wizard.Wizard;

import sota.app.Application;
import sota.ast.util.ProjectConfig;

/**
 * Der Wizard fr die Erstellung eines neuen Projektes.
 * 
 */
public class NewProjectWizard extends Wizard {
	private ProjectConfig config;

	/**
	 * Der Konstruktor des Wizards.
	 */
	public NewProjectWizard() {
		super();
		config = new ProjectConfig();
		setWindowTitle("New Project");
		addPage(new FirstWizardPage(config));
		addPage(new SecondWizardPage(config));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.wizard.Wizard#performFinish()
	 */
	@Override
	public boolean performFinish() {
		int nrFiles = 0;
		for (Object o : ((SecondWizardPage) getPage("Second Page")).getFileNames()) {
			if (((File) o).isFile()) {
				if (nrFiles++ == 0)
					Application.getInstance().getASTManager().reinit(config);
				Application.getInstance().getASTManager().addFile(((File) o).getAbsolutePath());
			}
		}
		if (nrFiles == 0)
			return false;

		Application.getInstance().getASTManager().fireToProjectChangeListeners();
		return true;
	}

}
