package sota.gui.preferences;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.ColorFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.RadioGroupFieldEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;

/**
 * Prferenzseite fr die CFGView.
 * 
 */
public class CFGViewPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {

	public static String ID = "sota.cfgviewpreferencepage";

	/**
	 * Der Konstruktor.
	 */
	public CFGViewPreferencePage() {
		super(GRID);

		setPreferenceStore(PlatformUI.getPreferenceStore());
		setDescription("Preferences for the CFG-View");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors()
	 */
	public void createFieldEditors() {

		addField(new BooleanFieldEditor(PreferenceConstants.CFG_SHOW_CONDITIONCOVERAGE_LABELS,
				"  &Show labels for condition coverage (nodes with conditions)", getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.CFG_SHOW_PATHCOVERAGE_LABELS,
				"  &Show labels for path coverage (function- and iterationnodes)", getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.CFG_SHOW_BASICOVERAGE_LABELS,
				"  &Show labels for basic coverage (functionnode)", getFieldEditorParent()));

		GridData data = new GridData(GridData.FILL_HORIZONTAL);
		data.horizontalSpan = 3;
		Label label1 = new Label(getFieldEditorParent(), SWT.SEPARATOR | SWT.HORIZONTAL);
		label1.setLayoutData(data);

		addField(new ColorFieldEditor(PreferenceConstants.CFG_NODE_DEF_COLOR, "  &Default CFG-Node:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.CFG_NODE_HIT_COLOR, "  &Visited CFG-Node:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.CFG_NODE_MISS_COLOR, "  &Not visited CFG-Node:",
				getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.CFG_SHOW_BRANCHING_NODE_COLOR,
				"  &Highlight branching nodes w/o all exits taken", getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.CFG_BRANCHINIG_NODE_COLOR, "  &Branching CFG-nodes :",
				getFieldEditorParent()));

		data = new GridData(GridData.FILL_HORIZONTAL);
		data.horizontalSpan = 3;
		Label label2 = new Label(getFieldEditorParent(), SWT.SEPARATOR | SWT.HORIZONTAL);
		label2.setLayoutData(data);

		addField(new ColorFieldEditor(PreferenceConstants.CFG_EDGE_DEF_COLOR, "  &Default CFG-Edge:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.CFG_EDGE_HIT_COLOR, "  &Visited CFG-Edge:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.CFG_EDGE_MISS_COLOR, "  &Not visited CFG-Edge:",
				getFieldEditorParent()));
		addField(new RadioGroupFieldEditor(PreferenceConstants.CFG_EDGE_WIDTH, "  &Width of CFG-Edges", 3,
				new String[][] { { "1pt", "1" }, { "2pt value", "2" }, { "3pt", "3" } }, getFieldEditorParent()));

		data = new GridData(GridData.FILL_HORIZONTAL);
		data.horizontalSpan = 3;
		Label label3 = new Label(getFieldEditorParent(), SWT.SEPARATOR | SWT.HORIZONTAL);
		label3.setLayoutData(data);
		/*
		 * label = new Label(getFieldEditorParent(), SWT.SEPARATOR | SWT.HORIZONTAL); label.setLayoutData(data);
		 * 
		 * /*addField(new RadioGroupFieldEditor( PreferenceConstants.CFG_EDGE_HIT_STYLE, "  &Style of visited Edges", 4,
		 * new String[][] { { "solid", "solid" }, { "dash", "dash" }, { "dot", "dot" }, { "dash-dot", "dash-dot" } },
		 * getFieldEditorParent())); addField(new RadioGroupFieldEditor( PreferenceConstants.CFG_EDGE_MISS_STYLE,
		 * "  &Style of not visited Edges", 4, new String[][] { { "solid", "solid" }, { "dash", "dash" }, { "dot", "dot"
		 * }, { "dash-dot", "dash-dot" } }, getFieldEditorParent())); addField(new RadioGroupFieldEditor(
		 * PreferenceConstants.CFG_EDGE_EXCEPTION_STYLE, "  &Style of Exception-Edges", 4, new String[][] { { "solid",
		 * "solid" }, { "dash", "dash" }, { "dot", "dot" }, { "dash-dot", "dash-dot" } }, getFieldEditorParent()));
		 */

		addField(new ColorFieldEditor(PreferenceConstants.CFG_CURR_LINE_COLOR, " &Current sourcode line:",
				getFieldEditorParent()));

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
	}

}