package sota.gui.preferences;

import org.eclipse.jface.preference.ColorFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IntegerFieldEditor;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;

/**
 * Prferenzseite fr die CoverageView.
 * 
 */

public class CoverageViewPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {

	public static String ID = "sota.coverageviewpreferencespage";

	/**
	 * Der Konstruktor.
	 */
	public CoverageViewPreferencePage() {
		super(GRID);

		setPreferenceStore(PlatformUI.getPreferenceStore());
		setDescription("Preferences for the CFG-View");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors()
	 */
	public void createFieldEditors() {
		addField(new IntegerFieldEditor(PreferenceConstants.COVERAGE_FIRST_BAR, "  &First Bar:", getFieldEditorParent()));
		addField(new IntegerFieldEditor(PreferenceConstants.COVERAGE_SECOND_BAR, "  &Second Bar:",
				getFieldEditorParent()));
		addField(new IntegerFieldEditor(PreferenceConstants.COVERAGE_THIRD_BAR, "  &Third Bar:", getFieldEditorParent()));
		addField(new IntegerFieldEditor(PreferenceConstants.COVERAGE_FOURTH_BAR, "  &Fourth Bar:",
				getFieldEditorParent()));
		addField(new IntegerFieldEditor(PreferenceConstants.COVERAGE_FIFTH_BAR, "  &Fifth Bar:", getFieldEditorParent()));

		addField(new ColorFieldEditor(PreferenceConstants.COVERAGE_TOP_BAR_COLOR, "  &100%:", getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.COVERAGE_FIRST_BAR_COLOR, "  &First Bar:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.COVERAGE_SECOND_BAR_COLOR, "  &Second Bar:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.COVERAGE_THIRD_BAR_COLOR, "  &Third Bar:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.COVERAGE_FOURTH_BAR_COLOR, "  &Fourth Bar:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.COVERAGE_FIFTH_BAR_COLOR, "  &Fifth Bar:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.COVERAGE_ABOVE_BOTTOM_BAR_COLOR, "  &Above 0%:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.COVERAGE_BOTTOM_BAR_COLOR, "  &0%:", getFieldEditorParent()));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
	}

}
