package sota.gui.preferences;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.FileFieldEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;

/**
 * Prferenzseite fr allgemeine Einstellungen.
 * 
 */

public class GeneralPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {

	public static String ID = "sota.generalpreferencepage";

	/**
	 * Der Konstruktor.
	 */
	public GeneralPreferencePage() {
		super(GRID);

		setPreferenceStore(PlatformUI.getPreferenceStore());
		setDescription("General Preferences");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors()
	 */
	@Override
	protected void createFieldEditors() {

		addField(new FileFieldEditor(PreferenceConstants.GENERAL_ANT_LOCATION, "  Location of Ant:",
				getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.GENERAL_CREATE_LOG, "  Create log file",
				getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.GENERAL_OVERWRITE_LOG, "  Overwrite existing log file.",
				getFieldEditorParent()));

		GridData data = new GridData(GridData.FILL_HORIZONTAL);
		data.horizontalSpan = 3;
		Label label1 = new Label(getFieldEditorParent(), SWT.SEPARATOR | SWT.HORIZONTAL);
		label1.setLayoutData(data);

		// addField(new BooleanFieldEditor(PreferenceConstants.GENERAL_LIST_FILE, "  List files in project.",
		// getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.GENERAL_PARSE_DIRTY, "  Parse instrumented sourcecode.",
				getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.GENERAL_AUTO_REBUILD,
				"  Automatically rebuild project on test stop.", getFieldEditorParent()));

		data = new GridData(GridData.FILL_HORIZONTAL);
		data.horizontalSpan = 3;
		Label label2 = new Label(getFieldEditorParent(), SWT.SEPARATOR | SWT.HORIZONTAL);
		label2.setLayoutData(data);

		// addField(new BooleanFieldEditor(PreferenceConstants.GENERAL_LIST_FILE, "  List files in project.",
		// getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.GENERAL_ENABLE_DEBUG, "  Enable debug modus.",
				getFieldEditorParent()));

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
		// TODO Auto-generated method stub

	}

}
