package sota.gui.preferences;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.ColorFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IntegerFieldEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;

/**
 * Prferenzseite fr die Reporterstellung.
 * 
 */

public class ReportPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {

	public final String ID = "sota.reportpreferencepage";

	/**
	 * Der Konstruktor.
	 */
	public ReportPreferencePage() {
		super(GRID);

		setPreferenceStore(PlatformUI.getPreferenceStore());
		setDescription("Preferences for the Report");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors()
	 */
	public void createFieldEditors() {

		addField(new BooleanFieldEditor(PreferenceConstants.REPORT_PROMPT_FILENAME, "  Prompt for file name.",
				getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.REPORT_OVERWRITE_REPORT, "  Overwrite existing report.",
				getFieldEditorParent()));

		GridData data = new GridData(GridData.FILL_HORIZONTAL);
		data.horizontalSpan = 2;
		Label label1 = new Label(getFieldEditorParent(), SWT.SEPARATOR | SWT.HORIZONTAL);
		label1.setLayoutData(data);

		addField(new BooleanFieldEditor(PreferenceConstants.REPORT_USE_ALL_TESTS, "  Use all tests for report",
				getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.REPORT_SHOW_TESTS, "  Show Tests", getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.REPORT_SHOW_CLASSES, "  Show Classes",
				getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.REPORT_IGNORE_INNER_CLASSES, "  Ignore inner classes",
				getFieldEditorParent()));
		addField(new BooleanFieldEditor(PreferenceConstants.REPORT_SHOW_FUNCTIONS, "  Show Functions",
				getFieldEditorParent()));

		// addField(new BooleanFieldEditor(PreferenceConstants.REPORT_SHOW_STATISTICS, "  Show Statistics",
		// getFieldEditorParent()));
		// addField(new BooleanFieldEditor(PreferenceConstants.REPORT_SHOW_OVERVIEW, "  Show Overview",
		// getFieldEditorParent()));

		addField(new IntegerFieldEditor(PreferenceConstants.REPORT_FONT_SIZE, "  Font size: ", getFieldEditorParent()));

		data = new GridData(GridData.FILL_HORIZONTAL);
		data.horizontalSpan = 2;
		Label label2 = new Label(getFieldEditorParent(), SWT.SEPARATOR | SWT.HORIZONTAL);
		label2.setLayoutData(data);

		addField(new BooleanFieldEditor(PreferenceConstants.REPORT_USE_COLORS, "  Use Colors", getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.REPORT_TOP_BAR_COLOR, "  &100%:", getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.REPORT_FIRST_BAR_COLOR, "  &First Bar:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.REPORT_SECOND_BAR_COLOR, "  &Second Bar:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.REPORT_THIRD_BAR_COLOR, "  &Third Bar:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.REPORT_FOURTH_BAR_COLOR, "  &Fourth Bar:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.REPORT_FIFTH_BAR_COLOR, "  &Fifth Bar:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.REPORT_ABOVE_BOTTOM_BAR_COLOR, "  &Above 0%:",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.REPORT_BOTTOM_BAR_COLOR, "  &0%:", getFieldEditorParent()));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
		// TODO Auto-generated method stub

	}

}
