package sota.gui.preferences;

import org.eclipse.jface.preference.ColorFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IntegerFieldEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;

/**
 * Prferenzseite fr die SourceView.
 * 
 */

public class SourceViewPreferencePage extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {

	public static String ID = "sota.sourceviewpreferencepage";

	/**
	 * Der Konstruktor.
	 */
	public SourceViewPreferencePage() {
		super(GRID);
		setPreferenceStore(PlatformUI.getPreferenceStore());
		setDescription("Preferences for the SourceView");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors()
	 */
	public void createFieldEditors() {
		GridData data = new GridData(GridData.FILL_HORIZONTAL);
		data.horizontalSpan = 2;
		data.verticalIndent = 10;

		addField(new ColorFieldEditor(PreferenceConstants.SOURCE_KEYWORD_COLOR, "  &Keywords:  ",
				getFieldEditorParent()));// getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.SOURCE_COMMENT_COLOR, "  &Comments:  ",
				getFieldEditorParent()));// getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.SOURCE_STRING_COLOR, "  &Strings:  ", getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.SOURCE_ASC_COLOR, "  &ASC-comments:  ",
				getFieldEditorParent()));

		addField(new IntegerFieldEditor(PreferenceConstants.SOURCE_INDENT_SIZE, "  &Indent size:  ",
				getFieldEditorParent()));

		data = new GridData(GridData.FILL_HORIZONTAL);
		data.horizontalSpan = 2;
		Label label1 = new Label(getFieldEditorParent(), SWT.SEPARATOR | SWT.HORIZONTAL);
		label1.setLayoutData(data);

		addField(new ColorFieldEditor(PreferenceConstants.SOURCE_LINE_HIT_COLOR, "  &Visited source lines:  ",
				getFieldEditorParent()));
		addField(new ColorFieldEditor(PreferenceConstants.SOURCE_LINE_MISS_COLOR, "  &Not visited source lines:  ",
				getFieldEditorParent()));

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
	}

}