package sota.gui.provider;

import java.io.File;
import java.util.ArrayList;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

/**
 * Der ContentProvider fr die Auflistung von Quelldateien in FileTrees.
 * 
 */
public class FileTreeContentProvider implements ITreeContentProvider {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IContentProvider#dispose()
	 */
	public void dispose() {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface.viewers.Viewer, java.lang.Object,
	 * java.lang.Object)
	 */
	public void inputChanged(Viewer arg0, Object arg1, Object arg2) {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ITreeContentProvider#getChildren(java.lang.Object)
	 */
	public Object[] getChildren(Object parent) {
		if (parent == null || ((File) parent).listFiles() == null)
			return null;
		ArrayList<Object> folderList = new ArrayList<Object>();
		ArrayList<Object> fileList = new ArrayList<Object>();
		for (Object o : ((File) parent).listFiles()) {
			if (((File) o).isDirectory()) {
				if (hasChildren(o))
					folderList.add(o);
			} else {
				if (((File) o).getName().endsWith(".java"))
					fileList.add(o);
			}
		}
		folderList.addAll(fileList);
		return folderList.toArray();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ITreeContentProvider#getParent(java.lang.Object)
	 */
	public Object getParent(Object arg0) {
		return ((File) arg0).getParentFile();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ITreeContentProvider#hasChildren(java.lang.Object)
	 */
	public boolean hasChildren(Object arg0) {
		Object[] obj = getChildren(arg0);
		return obj == null ? false : obj.length > 0;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
	 */
	public Object[] getElements(Object arg0) {
		Object[] obj = new Object[1];
		if (arg0 == null)
			return null;

		File file = new File((String) arg0);
		if (!file.exists()) {
			// Logger.logln("Can't find file");
			return new Object[0];
		}
		obj[0] = file;
		return obj;
	}

}
