package sota.gui.provider;

import java.util.Comparator;

/**
 * Interface fr alle Ansichten mit der Darstellung des Projektbaumees (ProjectView, CoverageView, MetricsView).
 * 
 */
public interface IProjectTreeView {

	/**
	 * Fragt, ob das Projekt selbst aufgefhrt werden soll.
	 * 
	 * @return true, wenn ja, sonst false
	 */
	abstract public boolean showProjectLine();

	/**
	 * Fragt, ob die Strukturen hierarchisch oder flach dargestellt werden sollen.
	 * 
	 * @return true, falls flach, false sonst
	 */
	abstract public boolean showFlat();

	/**
	 * Fragt,ob Paketnamen vorangestellt werden sollen.
	 * 
	 * @return true, wenn ja, false sonst
	 */
	abstract public boolean showPackageNames();

	/**
	 * Fragt, ob Dateien aufgefhrt werden sollen.
	 * 
	 * @return true, wenn ja, false sonst
	 */
	abstract public boolean showFiles();

	/**
	 * Fragt,ob innere Klassen aufgelistet werden sollen.
	 * 
	 * @return true, wenn ja, false sonst
	 */
	abstract public boolean showInnerClasses();

	/**
	 * Fragt, ob Klassen aufgefhrt werden sollen.
	 * 
	 * @return true, wenn ja, false sonst
	 */
	abstract public boolean showClasses();

	/**
	 * Fordert eine Vergleichsklasse an.
	 * 
	 * @return der Comparator
	 */
	@SuppressWarnings("unchecked")
	abstract public Comparator getComparator();

	/**
	 * Whlt ein Objekt der Struktur aus.
	 * 
	 * @param o
	 *            das Objekt der Struktur
	 */
	public abstract void select(Object o);
}
