package sota.gui.provider;

import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITableColorProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;

import sota.app.Application;
import sota.ast.nodes.IConditionNode;
import sota.ast.util.ColorManager;
import sota.gui.graph.GraphNode;

/**
 * Der LabelProvider fr die Bedingungsdarstellung in dem NodeInfoDialog.
 * 
 */
public class NodeDialogLabelProvider implements ITableLabelProvider, ITableColorProvider {
	IConditionNode n;
	GraphNode gn;

	/**
	 * Der Konstruktor.
	 * 
	 * @param gn
	 *            der zugehrige Graphnode zu der Bedingung
	 */
	public NodeDialogLabelProvider(GraphNode gn) {
		super();
		this.gn = gn;
		this.n = ((IConditionNode) gn.astNode);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnImage(java.lang.Object, int)
	 */
	public Image getColumnImage(Object element, int columnIndex) {
		// TODO Auto-generated method stub
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnText(java.lang.Object, int)
	 */
	public String getColumnText(Object element, int columnIndex) {
		if (element instanceof String) {
			switch (columnIndex) {
			case 0:
				return (String) element;
			case 1:
				return n.getCondition().evaluateTruthVector((String) element) + "";
			default:
				String s = n.getCondition().getEvaluatedTVString((String) element);
				if (s.substring(columnIndex - 2).startsWith("-"))
					return "-";
				return s.substring(columnIndex - 2).startsWith("1") + "";
			}
		}
		return "a";
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IBaseLabelProvider#addListener(org.eclipse.jface.viewers.ILabelProviderListener)
	 */
	public void addListener(ILabelProviderListener listener) {
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IBaseLabelProvider#dispose()
	 */
	public void dispose() {
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IBaseLabelProvider#isLabelProperty(java.lang.Object, java.lang.String)
	 */
	public boolean isLabelProperty(Object element, String property) {
		// TODO Auto-generated method stub
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.viewers.IBaseLabelProvider#removeListener(org.eclipse.jface.viewers.ILabelProviderListener)
	 */
	public void removeListener(ILabelProviderListener listener) {
		// TODO Auto-generated method stub

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ITableColorProvider#getBackground(java.lang.Object, int)
	 */
	@Override
	public Color getBackground(Object element, int columnIndex) {
		// if(columnIndex ==0) {
		if (element instanceof String
				&& (((String) element).equals(gn.firstMCDC) || ((String) element).equals(gn.secondMCDC)))
			return Application.getInstance().getColorManager().getColor(ColorManager.LBLUE);
		// }
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ITableColorProvider#getForeground(java.lang.Object, int)
	 */
	@Override
	public Color getForeground(Object element, int columnIndex) {
		// TODO Auto-generated method stub
		return null;
	}

}