/**
 * Not in use right now.
 */
package sota.gui.views;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.OperationCanceledException;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.swt.widgets.Display;

import sota.ast.nodes.ASTDoNode;
import sota.ast.nodes.ASTIfNode;
import sota.ast.nodes.ASTNode;
import sota.ast.nodes.FileNode;
import sota.ast.nodes.IStatementNode;

/**
 * Erstellt den Quellcode fr die SourceView und ermittelt berdeckte Zeilen.
 * 
 */
class SourceDocumentCreator implements IRunnableWithProgress {

	private final SourceView sourceView;
	private FileNode fileNode;

	/**
	 * Der Konstruktor
	 * 
	 * @param sourceView
	 *            die entsprechende SourceView
	 * @param n
	 *            der zu verarbeitende FileNode
	 */
	public SourceDocumentCreator(SourceView sourceView, FileNode n) {
		this.sourceView = sourceView;
		fileNode = n;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.operation.IRunnableWithProgress#run(org.eclipse.core.runtime.IProgressMonitor)
	 */
	public void run(final IProgressMonitor monitor) throws InvocationTargetException, InterruptedException {

		final ASTNode sn = fileNode.getStartNode();
		final ASTNode en = fileNode.getEndNode();

		ArrayList<Integer> coveredLines = sourceView.getCoveredLinesList();
		ArrayList<Integer> notCoveredLines = sourceView.getNotCoveredLinesList();

		try {
			monitor.beginTask("Creating SourceView", IProgressMonitor.UNKNOWN);

			final StringBuffer s = new StringBuffer();

			ASTNode n = sn;
			while (n != en) {

				s.append(n.getContent());

				if (n instanceof IStatementNode && !n.isVirtual()) {
					if (((IStatementNode) n).getNrHits() > 0)
						coveredLines.add(n.getLineNr());
					else
						notCoveredLines.add(n.getLineNr());
				} else if (n instanceof ASTDoNode) {
					if (((ASTDoNode) n).getIterationNode().getNrHits() > 0)
						coveredLines.add(n.getLineNr());
					else
						notCoveredLines.add(n.getLineNr());
				}
				if (n instanceof ASTIfNode && !((ASTIfNode) n).getElseNode().isVirtual()) {
					if (((ASTIfNode) n).getFalseNode().getNrHits() > 0)
						coveredLines.add(((ASTIfNode) n).getElseNode().getLineNr());
					else
						notCoveredLines.add(((ASTIfNode) n).getElseNode().getLineNr());
				}

				n = n.getNextNode();
				if (monitor.isCanceled())
					throw new OperationCanceledException();
				monitor.worked(1);
			}

			s.append(n.getContent() + "\n\n");

			Display.getDefault().syncExec(new Runnable() {
				public void run() {
					SourceDocumentCreator.this.sourceView.getFileDocument().set(s.toString());
					// SourceDocumentCreator.this.sourceView.setFileName(fileNode.getIDString());
				}

			});
		} finally {
			monitor.done();
		}
	}
}