package sota.lang.java.ast.nodes;

import sota.ast.nodes.ASTCaseNode;
import sota.lang.java.ast.util.JavaASCFormatter;

/**
 * AST-Knoten fr Case-Statements.
 * */
public class JavaASTCaseNode extends ASTCaseNode {

	/**
	 * Konstruktor fr Default-Case.
	 * 
	 * @param ln
	 *            die Zeilennummer
	 * @param s
	 *            der Inhalt
	 */
	public JavaASTCaseNode(int ln, String s) {
		super(ln, s);
	}

	/**
	 * Konstruktor fr normales Case.
	 * 
	 * @param ln
	 *            die Zeilennummer
	 * @param s
	 *            der Inhalt
	 * @param c
	 *            der konstante Ausdruck
	 */
	public JavaASTCaseNode(int ln, String s, String c) {
		super(ln, s, c);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see sota.ast.nodes.ASTNode#createASCContent(int)
	 */
	public void createASCContent(int level) {
		switch (level) {
		case 0:
			ascContent += content;
			break;
		case 1:
		case 2:
		case 3:
			ascContent += content + JavaASCFormatter.logId(id, "Case(" + id + ")");
			break;
		}
	}
}