package sota.lang.java.ast.nodes;

import sota.ast.nodes.ASTCatchNode;
import sota.ast.nodes.ASTCompoundNode;
import sota.lang.java.ast.util.JavaASCFormatter;

/**
 * AST-Knoten fr Catch-Blocks
 * */
public class JavaASTCatchNode extends ASTCatchNode {

	/**
	 * Konstruktor fr Finally-Knoten.
	 * 
	 * @param nl
	 *            die Zeilennummer
	 * @param s
	 *            der Inhalt
	 */
	public JavaASTCatchNode(int nl, String s) {
		super(nl, s);
	}

	/**
	 * Konstruktof fr normales Catch.
	 * 
	 * @param nl
	 *            die Zeilennummer
	 * @param s
	 *            der Inhalt
	 * @param para
	 *            der Parameter
	 */
	public JavaASTCatchNode(int nl, String s, String para) {
		super(nl, s, para);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see sota.ast.nodes.ASTNode#createASCContent(int)
	 */
	public void createASCContent(int level) {
		switch (level) {
		case 0:
			appendToASCContent(content);
			break;
		case 1:
		case 2:
		case 3:
			appendToASCContent(content + JavaASCFormatter.startCompound() + JavaASCFormatter.logId(id, "Catch"));

			((ASTCompoundNode) next).getEndNode().appendToASCContent(JavaASCFormatter.endCompound());
			break;
		}
	}
}