package sota.lang.java.ast.nodes;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.TreeSet;

import sota.ast.nodes.Condition;
import sota.ast.nodes.IConditionNode;
import sota.ast.util.Metrics;
import sota.lang.java.ast.util.JavaASCFormatter;

/**
 * Ermglicht die Verarbeitung von ternren Operatoren. Aufgrund der fehlenden Sicherstellung der Nebeneffektfreiheit
 * momentan nicht verwendet!
 * 
 */
public class JavaASTCondStatementNode extends JavaASTStatementNode implements IConditionNode {

	public JavaASTCondStatementNode(int ln, String s) {
		super(ln, s);
	}

	protected Condition cond;

	protected ArrayList<Condition> listOfConditions = new ArrayList<Condition>();

	protected HashSet<String> setOfTruthVectors = new HashSet<String>();

	public void createASCContent(int level) {
		switch (level) {
		case 0:
		case 1:
			appendToASCContent(content);
			break;
		case 2:
		case 3:
			if (isReachable) {
				ascContent = JavaASCFormatter.logCondition(id, "Conditional Statement", cond) + ascContent + content;
			} else
				appendToASCContent(content);
			break;
		}
	}

	public void fillConditions(TreeSet<String> list) {
		setOfTruthVectors.addAll(list);
		for (String s : list) {
			cond.applyTruthVector(s);
		}
		return;
	}

	/** numeriert die Konditionen, startend mit Parameterwert */

	public Condition getCondition() {
		return cond;
	}

	public ArrayList<Condition> getListOfConditions() {
		return listOfConditions;
	}

	public void resetHits() {
		super.resetHits();
		setOfTruthVectors.clear();
		if (cond != null)
			cond.resetHits();
	}

	public HashSet<String> getTruthVectors() {
		return setOfTruthVectors;
	}

	public void resetTruthVector() {
		setOfTruthVectors.clear();
	}

	public void computeConditionCoverage() {
		if (cond == null)
			return;

		cond.computeConditionCoverage(setOfTruthVectors);
	}

	public int getNrConditions() {
		if (cond != null)
			return cond.getNrConditions();
		return 0;
	}

	public int numerateCondition(int i) {
		if (cond == null)
			return i;
		return cond.numerate(i);
	}

	public String getEvaluatedTVString(String s) {
		if (cond == null)
			return "";
		return (cond.evaluateTruthVector(s) ? "1" : "0") + cond.getEvaluatedTVString(s);
	}

	public boolean hasNonTrivialCondition() {
		if (cond == null)
			return false;
		return cond.isNonTrivial();
	}

	public Metrics getMetrics() {
		if (cond != null)
			return cond.getMetrics();
		return new Metrics();
	}
}