package sota.lang.java.ast.nodes;

import sota.ast.nodes.ASTJumpNode;
import sota.lang.java.ast.util.JavaASCFormatter;

/**
 * AST-Knoten fr Sprunganweisungen (break, continue, return)
 * */
public class JavaASTJumpNode extends ASTJumpNode {
	/**
	 * Konstruktor
	 * 
	 * @param ln
	 *            die Zeilennummer
	 * @param s
	 *            der Inhalt
	 * @param l
	 *            das Label
	 */
	public JavaASTJumpNode(int ln, String s, String l) {
		super(ln, s, l);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see sota.ast.nodes.ASTNode#createASCContent(int)
	 */
	public void createASCContent(int level) {
		switch (level) {
		case 0:
			appendToASCContent(content);
			break;
		case 1:
		case 2:
			if (!isVirtual) {
				ascContent = JavaASCFormatter.insertComment("Jump(" + id + " -> " + targetNode.getID() + ")")
						+ ascContent + content;
			}
			break;
		case 3:
			if (!isVirtual) {
				ascContent = JavaASCFormatter.logId(id, "Jump(" + id + " -> " + targetNode.getID() + ")") + ascContent
						+ content;
			}
		}
	}
}