package sota.lang.java.ast.nodes;

import sota.ast.nodes.ASTStatementNode;
import sota.lang.java.ast.util.JavaASCFormatter;

/**
 * AST-Knoten fr Statements
 * */
public class JavaASTStatementNode extends ASTStatementNode {
	/**
	 * Konstruktor fr nichtvirtuelle Anweisungen.
	 * 
	 * @param ln
	 *            die Zeilennummer
	 * @param s
	 *            der Inhalt
	 */
	public JavaASTStatementNode(int ln, String s) {
		super(ln, s);
	}

	/**
	 * Konstruktor fr virtuelle Anweisungen.
	 * 
	 * @param ln
	 *            die Zeilennummer
	 */
	public JavaASTStatementNode(int ln) {
		super(ln);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see sota.ast.nodes.ASTNode#createASCContent(int)
	 */
	public void createASCContent(int level) {
		switch (level) {
		case 0:
		case 1:
		case 2:
			appendToASCContent(content);
			break;
		case 3:
			if (isVirtual || !isReachable)
				appendToASCContent(content);
			else
				ascContent = JavaASCFormatter.logId(id, "Statement") + ascContent + content;
			break;
		}
	}
}