package sota.lang.java.ast.nodes;

import sota.ast.nodes.ASTNode;
import sota.ast.nodes.ASTSwitchNode;
import sota.lang.java.ast.util.JavaASCFormatter;

/**
 * AST-Knoten fr Switch-Statements
 * */
public class JavaASTSwitchNode extends ASTSwitchNode {
	/**
	 * Konstruktor
	 * 
	 * @param ln
	 *            die Zeilennummer
	 * @param s
	 *            der Inhalt
	 */
	public JavaASTSwitchNode(int ln, String s) {
		super(ln, s);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see sota.ast.nodes.ASTNode#createASCContent(int)
	 */
	public void createASCContent(int level) {
		switch (level) {
		case 0:
			ascContent += content;
			break;
		case 1:
		case 2:

			if (!isVirtual) {
				/*
				 * ascContent = JavaASCFormatter.logId( id, "Switch(" + id + ")") + ascContent + content;
				 */
				entryNode.setASCContent(JavaASCFormatter.insertComment("Switch(" + id + ")")
						+ entryNode.getASCContent());
				ascContent += content;
				for (ASTNode n : setOfExitNodes)
					n.setASCContent(JavaASCFormatter.insertComment("Switch-Exit(" + id + ")") + n.getASCContent());
			}
			break;
		case 3:
			if (!isVirtual) {
				/*
				 * ascContent = JavaASCFormatter.logId( id, "Switch(" + id + ")") + ascContent + content;
				 */
				entryNode.setASCContent(JavaASCFormatter.logId(id, "Switch(" + id + ")") + entryNode.getASCContent());
				ascContent += content;
				for (ASTNode n : setOfExitNodes) {
					if (n == endNode)
						n.setASCContent(JavaASCFormatter.logId(n.getID(), "Switch-Exit(" + id + ")")
								+ n.getASCContent());
					else
						n.setASCContent(JavaASCFormatter.insertComment("Switch-Exit(" + id + ")") + n.getASCContent());
				}
			}
			break;
		}
	}
}