package sota.lang.java.ast.nodes;

import sota.ast.nodes.ASTNode;
import sota.ast.nodes.ASTTryNode;
import sota.lang.java.ast.util.JavaASCFormatter;

/**
 * AST-Knoten fr Try-Blcke
 * */
public class JavaASTTryNode extends ASTTryNode {
	/**
	 * der Konstruktor
	 * 
	 * @param ln
	 *            die Zeilennummer
	 * @param s
	 *            der Inhalt
	 */
	public JavaASTTryNode(int ln, String s) {
		super(ln, s);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see sota.ast.nodes.ASTNode#createASCContent(int)
	 */
	public void createASCContent(int level) {
		switch (level) {
		case 0:
			appendToASCContent(content);
			break;
		case 1:
		case 2:
			ascContent = JavaASCFormatter.insertComment("Try(" + id + ")") + ascContent + content;
			// entryOfTryBlock.setASCContent(JavaASCFormatter.logId(entryOfTryBlock.getID(), "Try-Block(" +
			// entryOfTryBlock.getID() + ")"));

			for (ASTNode n : setOfExitNodes) {
				n.setASCContent(JavaASCFormatter.insertComment("Try-Exit(" + id + ")") + n.getASCContent());
			}

			break;

		case 3:
			ascContent = JavaASCFormatter.logId(id, "Try(" + id + ")") + ascContent + content;

			entryOfTryBlock.setASCContent(JavaASCFormatter.logId(entryOfTryBlock.getID(), "Try-Block("
					+ entryOfTryBlock.getID() + ")"));

			for (ASTNode n : setOfExitNodes) {
				if (n == endNode)
					n.setASCContent(JavaASCFormatter.logId(n.getID(), "Try-Exit(" + id + ")") + n.getASCContent());
				else
					n.setASCContent(JavaASCFormatter.insertComment("Try-Exit(" + id + ")") + n.getASCContent());
			}

			break;
		}
	}
}