/* Generated By:JavaCC: Do not edit this line. Token.java Version 3.0 */
package sota.lang.java.ast.parser;

/**
 * Describes the input token stream.
 */

public class Token {
	/**
	 * An integer that describes the kind of this token. This numbering system is determined by JavaCCParser, and a
	 * table of these numbers is stored in the file ...Constants.java.
	 */
	public int kind;

	public boolean isSpecialToken = false;

	/**
	 * beginLine and beginColumn describe the position of the first character of this token; endLine and endColumn
	 * describe the position of the last character of this token.
	 */
	public int beginLine, beginColumn, endLine, endColumn;

	/**
	 * The string image of the token.
	 */
	public String image;

	/**
	 * A reference to the next regular (non-special) token from the input stream. If this is the last token from the
	 * input stream, or if the token manager has not read tokens beyond this one, this field is set to null. This is
	 * true only if this token is also a regular token. Otherwise, see below for a description of the contents of this
	 * field.
	 */
	public Token next;

	/**
	 * This field is used to access special tokens that occur prior to this token, but after the immediately preceding
	 * regular (non-special) token. If there are no such special tokens, this field is set to null. When there are more
	 * than one such special token, this field refers to the last of these special tokens, which in turn refers to the
	 * next previous special token through its specialToken field, and so on until the first special token (whose
	 * specialToken field is null). The next fields of special tokens refer to other special tokens that immediately
	 * follow it (without an intervening regular token). If there is no such token, this field is null.
	 */
	public Token specialToken;

	/**
	 * Returns the image. Returning only one ">" removes Gessers hack of changing the content of the Tokenstream.
	 */
	public String toString() {
		if (kind == JavaParserConstants.GT) {
			if (((Token.GTToken) this).realKind == JavaParserConstants.RUNSIGNEDSHIFT)
				return ">";
			if (((Token.GTToken) this).realKind == JavaParserConstants.RSIGNEDSHIFT)
				return ">";
			if (((Token.GTToken) this).realKind == JavaParserConstants.GT)
				return ">";
		}
		return image;
	}

	public String allToString() {
		return specialTokenToString() + toString();
	}

	/**  */
	// Fgt t als SpecialToken vor das Token ein
	public void prefixSpecialToken(Token prefix) {
		Token last = prefix.specialToken;
		if (last != null) {
			while (last.specialToken != null) {
				last = last.specialToken;
			}
		} else {
			last = prefix;
		}
		if (specialToken == null) {
			last.specialToken = null;
			if (isSpecialToken) {
				prefix.next = this;
			} else {
				prefix.next = null;
			}
			specialToken = prefix;
		} else {
			specialToken.next = last;
			last.specialToken = specialToken;
			if (isSpecialToken) {
				prefix.next = this;
			} else {
				prefix.next = null;
			}
			specialToken = prefix;
		}
	}

	// Fgt String s als SpecialToken vor das Token ein
	public void prefixSpecialToken(String s) {
		Token prefix = newToken(999);
		prefix.image = s;
		prefix.isSpecialToken = true;
		prefixSpecialToken(prefix);
	}

	/**  */
	// gibt vorangehende Specialtoken sowie Tokenimage aus
	public void print() {
		System.out.print(specialTokenToString());
		System.out.print(toString());
	}

	// gibt nur Tokenimage aus (keine SpecialToken, Cfg)
	public void printTokenOnly() {
		System.out.print(toString());
	}

	// gibt alle Token von diesem bis zu "end" aus (oder dem letzen)
	public void printTill(Token end) {
		Token t = this;
		while (t != null && t != end) {
			t.print();
			t = t.next;
		}
		if (t != null) {
			t.print();
		}
	}

	// gibt alle vorangehenden SpecialToken als ein String zurck
	public String specialTokenToString() {
		String s = "";
		Token p;
		if (specialToken == null) {
			return s;
		}
		p = specialToken;
		while (p.specialToken != null) {
			p = p.specialToken;
		}
		while (p != null) {
			s += p.toString();
			p = p.next;
		}
		return s;
	}

	public String sumUpX(Token t) {
		String s = "";
		Token p = t;
		while (p != null && p != this) {
			s += p.specialTokenToString() + p.toString();
			p = p.next;
		}
		return s;
	}

	public String sumUpXWithoutSpecialTokens(Token t) {
		String s = "";
		Token p = t;
		while (p != null && p != this) {
			s += p.toString();
			p = p.next;
		}
		return s;
	}

	// ((Token.GTToken)getToken(1)).realKind

	public String sumUp(Token t) {
		return sumUpX(t) + specialTokenToString() + toString();
	}

	public String sumUpWithoutSpecialTokens(Token t) {
		return sumUpXWithoutSpecialTokens(t) + toString();
	}

	public int prefixLength() {
		return specialTokenToString().length();
	}

	/**
	 * Returns a new Token object, by default. However, if you want, you can create and return subclass objects based on
	 * the value of ofKind. Simply add the cases to the switch for all those special cases. For example, if you have a
	 * subclass of Token called IDToken that you want to create if ofKind is ID, simlpy add something like :
	 * 
	 * case MyParserConstants.ID : return new IDToken();
	 * 
	 * to the following switch statement. Then you can cast matchedToken variable to the appropriate type and use it in
	 * your lexical actions.
	 */
	public static final Token newToken(int ofKind) {
		switch (ofKind) {
		default:
			return new Token();
		case JavaParserConstants.RUNSIGNEDSHIFT:
		case JavaParserConstants.RSIGNEDSHIFT:
		case JavaParserConstants.GT:
			return new GTToken();
		}
	}

	public static class GTToken extends Token {

		int realKind = JavaParserConstants.GT;
	}

}
